unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, VirtualTrees;

type
  // This data record contains all necessary information about a particular file system object.
  // This can either be a folder (virtual or real) or an image file.
  PFileData = ^TFileData;
  TFileData = record
    Caption : String;
end;

type

  { TForm1 }

  TForm1 = class(TForm)
    CloseBTN: TButton;
    ClearBTN: TButton;
    FillBTN: TButton;
    TotalCountTXT: TLabel;
    Tree: TVirtualStringTree;
    procedure ClearBTNClick(Sender: TObject);
    procedure CloseBTNClick(Sender: TObject);
    procedure FillBTNClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TreeFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
  private

  public
    Data : PFileData;
    Node : PVirtualNode;
    ProgrammPath : string;
    TreeFile : string;
  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.FillBTNClick(Sender: TObject);
var i : integer;
begin
   for i := 1 to 15 do
     begin
      Node := Tree.AddChild(Tree.RootNode);
      Data := Tree.GetNodeData(Node);
     end;

   TotalCountTXT.Caption := 'TotalCount: ' + IntToStr(Tree.TotalCount);
end;

procedure TForm1.CloseBTNClick(Sender: TObject);
begin
  Tree.SaveToFile(ProgrammPath+'\Files.db');
  Close;
end;

procedure TForm1.ClearBTNClick(Sender: TObject);
begin
  Tree.Clear;
  If FileExists(TreeFile) then
    DeleteFile(TreeFile);
  TotalCountTXT.Caption := 'TotalCount: ' + IntToStr(Tree.TotalCount);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Tree.NodeDataSize := SizeOf(TFileData);
   ProgrammPath := ExtractFilePath(Application.ExeName);
   TreeFile := ProgrammPath+'\Files.db';

   If FileExists(TreeFile) then
     Tree.LoadFromFile(TreeFile);

   TotalCountTXT.Caption := 'TotalCount: ' + IntToStr(Tree.TotalCount);
end;

procedure TForm1.TreeFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  Data1: PFileData;
begin
  Data1 := Sender.GetNodeData(Node);
  Finalize(Data1^); // Clear string data.
end;

end.

